# Frequently asked questions about ezcrypt

## Is ezcrypt recommended for production use?

No.

It is a serious project with a clear focus on security and safety, and great care is taken to ensure a robust architecture. However, it has not yet received adequate security review nor significant field testing. Thus, it is not recommended that you trust ezcrypt blindly.

## How can I reencrypt a file?

To reencrypt a file, e.g. to change the passphrase or change the KDF cost, you can decrypt-and-encrypt the file via a pipe. For example, to change the passphrase and set the KDF cost to 3:

```bash
ezcrypt -d -c -E OLDPASS file.z | ezcrypt -o file-new.z -E NEWPASS -3
```

This assumes that the old and new passphrases are stored in the environment variables `$OLDPASS` and `$NEWPASS`, respectively.

*NOTE: Make sure to not expose the secrets in your shell history and/or shell environment (e.g. use `unset OLDPASS NEWPASS; history -c` in bash).*

This method also works for migrating an encrypted file from an old version of ezcrypt to a new version, if necessary (decrypt with the old ezcrypt version and encrypt with the new ezcrypt version).

