#!/usr/bin/env bash
# -*- mode: bash; tab-width: 4; indent-tabs-mode: nil; -*-

set -o errexit

PROJ_ROOT=$(cd -- "$( dirname -- "${BASH_SOURCE[0]}" )"/.. &> /dev/null && pwd)

BUILD_ROOT=${PROJ_ROOT}/out
if [ "$#" -eq 1 ]; then
    BUILD_ROOT=$1
fi

echo "[ clang-tidy ]"
if command -v clang-tidy &> /dev/null
then
    SRCS=$(find "${PROJ_ROOT}/src" -regex '.*\.c')
    clang-tidy --quiet -p="${BUILD_ROOT}" ${SRCS}
else
    echo "***Warning: clang-tidy not found"
fi

echo "[ cmake-lint ]"
if command -v cmake-lint &> /dev/null
then
    SRCS=$(find "${PROJ_ROOT}/src" -regex '\(.*CMakeLists\.txt\|.*\.cmake\)')
    cmake-lint ${SRCS}
else
    echo "***Warning: cmake-lint not found"
fi
