// -*- mode: c; tab-width: 2; indent-tabs-mode: nil; -*-
//------------------------------------------------------------------------------
// This is free and unencumbered software released into the public domain.
//
// Anyone is free to copy, modify, publish, use, compile, sell, or
// distribute this software, either in source code form or as a compiled
// binary, for any purpose, commercial or non-commercial, and by any
// means.
//
// In jurisdictions that recognize copyright laws, the author or authors
// of this software dedicate any and all copyright interest in the
// software to the public domain. We make this dedication for the benefit
// of the public at large and to the detriment of our heirs and
// successors. We intend this dedication to be an overt act of
// relinquishment in perpetuity of all present and future rights to this
// software under copyright law.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//
// For more information, please refer to <https://unlicense.org/>
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Helper unit for parsing command line arguments.
//------------------------------------------------------------------------------

#ifndef ARGUMENTS_H_
#define ARGUMENTS_H_

#include <stdbool.h>

#define ARG_CMD_HELP 0
#define ARG_CMD_ENCRYPT 1
#define ARG_CMD_DECRYPT 2
#define ARG_CMD_VERSION 3
#define ARG_CMD_EDIT 4
#define ARG_CMD_MAKE_PEPPER 5
#define ARG_CMD_TEST 6

typedef struct {
  const char* program;
  const char* infile;
  const char* outfile;
  const char* editor;
  const char* passphrase_env;
  const char* passphrase_file;
  const char* pepper_file;
  int command;
  int cost;
  bool is_ezdecrypt;
  bool write_to_stdout;
  bool keep;
  bool force;
  bool disallow_gui;
  bool allow_empty_passphrase;
} args_t;

bool parse_args(int argc, char** argv, args_t* args);

#endif  // ARGUMENTS_H_
