// -*- mode: c; tab-width: 2; indent-tabs-mode: nil; -*-
//------------------------------------------------------------------------------
// This is free and unencumbered software released into the public domain.
//
// Anyone is free to copy, modify, publish, use, compile, sell, or
// distribute this software, either in source code form or as a compiled
// binary, for any purpose, commercial or non-commercial, and by any
// means.
//
// In jurisdictions that recognize copyright laws, the author or authors
// of this software dedicate any and all copyright interest in the
// software to the public domain. We make this dedication for the benefit
// of the public at large and to the detriment of our heirs and
// successors. We intend this dedication to be an overt act of
// relinquishment in perpetuity of all present and future rights to this
// software under copyright law.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//
// For more information, please refer to <https://unlicense.org/>
//------------------------------------------------------------------------------

#ifndef STRINGUTILS_H_
#define STRINGUTILS_H_

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

bool string_copy(const char* src, char* dst, size_t dst_size);

size_t numchars_utf8(const char* str);
size_t numchars_utf16(const uint16_t* str);

bool utf8_to_utf16(const char* src, uint16_t* dst, size_t dst_size);
bool utf16_to_utf8(const uint16_t* src, char* dst, size_t dst_size);

// Use free() to free a string that is returned by these functions.
// Can not return NULL.
uint16_t* utf8_to_utf16_alloc(const char* str);
char* utf16_to_utf8_alloc(const uint16_t* str);

#endif  // STRINGUTILS_H_
